      program rotate
c###########################################################################
c rotate.f -- part of miLD
c miLD -- (C) 2002 Y. Aulchenko, EMC Rotterdam, Inst. Cytol. Genet. SD RAS
c contact: yuriisa@bionet.nsc.ru
c This program is distributed under the terms of GNU Public license (GPL)
c modified 03-09-2002 (inserted bootstrap; change input-interface to stdin)
c modified 11-11-2002 (mean D' in bootstrap output)
c modified 14-11-2002 (seed-dropping to seed.rlux added)
c last modified 17-11-2002 (seed-dropping to seed.rlux using RLUXUT)
c###########################################################################

	parameter (MAXIDS=10000,MAXALL=50,NTOTROT=1000,NBOOS=1000)
	common /data/ isampleped(MAXIDS,2),nids
	character*256 tname1,tname2
	dimension iped(MAXIDS,2),itempped(MAXIDS),iorder(NBOOS),iorder2(NBOOS)
	INTEGER DATE_TIME (8)
	CHARACTER (LEN = 12) REAL_CLOCK (3)
	double precision pdis_dp(NBOOS),pdis_dp2(NBOOS),sumd,ssq,dprim,var,pmean,ppprot,
     :	init_dp
	integer*1 doboo,dump
	dimension iiiseed(25)

c start read in haplotype file
c	open(1,file="temp.rot")
	read(*,*) doboo,scale,pboo_left,pboo_right,dump 
	icount=0
      DO WHILE (iped(icount,1).ne.-999)
        icount = icount + 1
        READ (*, *) (iped(icount,i),i=1,2)
      END DO
c	print *,"nlines=",icount
	nids=icount-1
	if (nids>MAXIDS) then 
		print 'MAXIDS exceeded. Change MAXIDS to greater value in rotate.f and recompile.';
		stop
	endif
c	close(1)
c finish read in haplotype file

c start calculate dprime
c set isampleped = iped
	do i=1,2;do j=1,nids;isampleped(j,i)=iped(j,i);enddo;enddo

	init_dp = calcdprim()
c finish calculate dprime


c REMOVE c in final release!!!!!!
	call rndseed()
c REMOVE c in final release!!!!!!

	do i=1,NBOOS
		iorder(i)=1;
		iorder2(i)=1;
	enddo

	if (doboo.gt.0) then
c start possibly very laborous bootstrap sample(/adjusted D' -- if doboo==2) calculations
	do i=1,NBOOS
c start make bootstrap-sample
		pdis_dp(i)=0.0
		pdis_dp2(i)=0.0
		iwrids=nids
		do j=1,nids
			prnd = rndnum();
			icid = iwrids * prnd + 1
			if (icid>iwrids) stop 'icid>iwrids!!!'
			if (icid<1) stop 'icid<1!!!'
			isampleped(j,1)=iped(icid,1)
			isampleped(j,2)=iped(icid,2)
		enddo
c finish make bootstrap-sample

c pdis_dp contains D' of the bootstrap-sample
	pdis_dp(i)=calcdprim()

	
	if (doboo.gt.1) then
	sumd=0.0;
	ssq=0.0
	do ikiki=1,NTOTROT*scale
c start permutate arrays isampleped(1,*) and isampleped(2,*)
		do iz=1,2
			iwrids=nids
			itmpids=1
			do k=1,nids
				prnd = rndnum();
				icid = iwrids * prnd + 1
				if (icid>iwrids) stop 'icid>iwrids!!!'
				if (icid<1) stop 'icid<1!!!'
				itempped(itmpids)=isampleped(icid,iz);
				do j=icid,nids-1;
					isampleped(j,iz)=isampleped(j+1,iz);
				enddo
				iwrids=iwrids-1;itmpids=itmpids+1
			enddo
			do k=1,nids
				isampleped(k,iz)=itempped(k);
			enddo
		enddo
c finish permutate arrays isampleped(1,*) and isampleped(2,*)
		dprim = calcdprim()
c sumd is the sum of D's generated in permutations
		sumd=sumd+dprim;
c ssq is the sum of squares of D's generated in permutations
		ssq =ssq+dprim*dprim;
	enddo
	PPPROT=NTOTROT*scale
c pmean is expectation of D' under null
	pmean = sumd / PPPROT
	pdis_dp2(i)=pdis_dp(i)-pmean
	endif
	enddo
c finish very laborous bootstrap sample/adjusted D' calculations
	call sortrx(NBOOS,pdis_dp,iorder)
	call sortrx(NBOOS,pdis_dp2,iorder2)
	if (dump .eq. 1) then
		open(1,file="booDprim.dump",status='OLD',access='APPEND')
		write(1,"(10000e12.4)") ((pdis_dp(iorder(i))),i=1,NBOOS)
		close (1)
		if (doboo.eq.2) then 
			open(1,file="booDadj.dump",status='OLD',access='APPEND')
			write(1,"(10000e12.4)") ((pdis_dp2(iorder2(i))),i=1,NBOOS)
			close (1)
		endif
	endif

	endif



	sumd=0.0;
	ssq=0.0
c start permutations to calculate E[D'] under null
	do iii=1,NTOTROT

c set isampleped = iped
	do i=1,2;do j=1,nids;isampleped(j,i)=iped(j,i);enddo;enddo

c start permutate arrays isampleped(1,*) and isampleped(2,*)
	do i=1,2
		iwrids=nids
		itmpids=1
		do k=1,nids
			prnd = rndnum();
			icid = iwrids * prnd + 1
			if (icid>iwrids) stop 'icid>iwrids!!!'
			if (icid<1) stop 'icid<1!!!'
			itempped(itmpids)=isampleped(icid,i);
			do j=icid,nids-1;
				isampleped(j,i)=isampleped(j+1,i);
			enddo
			iwrids=iwrids-1;itmpids=itmpids+1
		enddo
		do k=1,nids
			isampleped(k,i)=itempped(k);
		enddo
	enddo
c finish permutate arrays isampleped(1,*) and isampleped(2,*)

	dprim = calcdprim()
	
c sumd is the sum of D's generated in permutations
	sumd=sumd+dprim;
c ssq is the sum of squares of D's generated in permutations
	ssq =ssq+dprim*dprim;

	enddo
c finish permutations to calculate E[D'] under null

	PPPROT=NTOTROT
c pmean is expectation of D' under null
	pmean = sumd / PPPROT
c var is variance of D' under null
	var = (ssq - 1000.0*pmean*pmean)/(PPPROT - 1.0)

c print out E[D'] under null, VAR[D'] under null;
	pmedpboo=9.9998
	if ((doboo.eq.1).or.(doboo.eq.2).or.(dboo.eq.3)) then
		PBOOS=NBOOS
		sisum=0.0
		do k=1,NBOOS
		    sisum=sisum+pdis_dp(k)
		enddo
		pmedpboo=sisum/PBOOS
		pq5=PBOOS*pboo_left
		pq95=PBOOS*pboo_right
		iq5 = int(pq5)
		iq95 = int(pq95)
c print out E[D'] under null, VAR[D'] under null, d-prime, 5%-quantile d-prime,
c 95%-quantile d-prime, 5%-quantile d-prime-adjusted, 95%-quantile d-prime-adjusted,
c number_of_bootstrap-samples, mean d' in bootstrap samples
		print *,pmean,var,init_dp,pdis_dp(iorder(iq5)),pdis_dp(iorder(iq95)),
     :			pdis_dp2(iorder2(iq5)),pdis_dp2(iorder2(iq95)),iq5,iq95,pboos,
     :                  pmedpboo
	else
c print out E[D'] under null, VAR[D'] under null, d-prime
		print *,pmean,var,init_dp,9.9999,9.9999,9.9999,9.9999,9.9999
	endif

	call rluxut(iiiseed)
	open(19,file="seed.rlux")
	do i=1,25
	    write (19,*) iiiseed(i)
	enddo
	call rluxat(i1,i2,i3,i4)
	write (19,*) i1,i2,i3,i4
	close(19)

      end

c----------------------------------------------------------------------------------

	function calcdprim()
	parameter (MAXIDS=10000,MAXALL=50,NTOTROT=1000,NBOOS=1000)
	common /data/ isampleped(MAXIDS,2),nids
     	dimension ifreqi(MAXALL),ifreqj(MAXALL),ifrij(MAXALL,MAXALL)
	double precision Pi(MAXALL),Pj(MAXALL),Pij(MAXALL,MAXALL),
     :dprim,calcdprim,pexp,d0,dmax

c start ensure the frequencies of alleles are 0
	     do kk=1,MAXALL;
		     ifreqi(kk)=0.;ifreqj(kk)=0.;
		     do ll=1,MAXALL;
			     ifrij(kk,ll)=0.;
		     enddo;
	     enddo
c finish ensure the frequencies of alleles are 0

c start count frequencies of alleles and haplotypes
	     imax=0;jmax=0;
	     do kk=1,nids;
		     na1=isampleped(kk,1);na2=isampleped(kk,2);
		     if (imax<na1) imax=na1; 
		     if (jmax<na2) jmax=na2;
		     if (na1>MAXALL.or.na2>MAXALL) then
			     print 'MAXALL exceeded. Change MAXALL to greater value in rotate.f and recompile.';
			     stop
		     endif
		     ifreqi(na1)=ifreqi(na1)+1;
		     ifreqj(na2)=ifreqj(na2)+1;
		     ifrij(na1,na2)=ifrij(na1,na2)+1;
	     enddo;
c finish count frequencies of alleles and haplotypes

c start calculate proportions from frequencies
	     do kk=1,imax;pi(kk)=(1.0*ifreqi(kk))/(1.0*nids);enddo
	     do kk=1,jmax;pj(kk)=(1.0*ifreqj(kk))/(1.0*nids);enddo
	     do kk=1,imax;do ll=1,jmax;
		     pij(kk,ll)=ifrij(kk,ll)/(1.0*nids);
	     enddo;enddo
c finish calculate proportions from frequencies

c start calculate d-prime
	     dprim=0.0;
	     do kk=1,imax;do ll=1,jmax;
		     pexp=Pi(kk)*Pj(ll);
		     d0=pij(kk,ll)-pexp;
		     if (d0<0) then 
			     dmax=min(pexp,(1.-pi(kk))*(1.-pj(ll)))
		     else
			     dmax=min((1.-pi(kk))*pj(ll),pi(kk)*(1.-pj(ll)))
		     endif
		     if (dmax.gt.0) dprim = dprim + pexp * abs(d0) / dmax;
	     enddo;enddo
c finish calculate d-prime

	calcdprim = dprim

	return
	end

	include 'randoml.f'

	include 'quick_sort2.f'


